#!/bin/bash
SCRIPTDIR=`dirname $0`
CURDIR=`pwd`
USRID=`id -u`
GID=`id -g`
cd $SCRIPTDIR
SCRIPTDIR=`pwd`
cd ..

cd $CURDIR
#echo "CURR_DIR=${CURR_DIR}"


export PATH=${PATH}:.

cd ${0%/*}

if [ ! -f ${SCRIPTDIR}/agentStarter.properties ]
then
echo echo Cannot find agentStarter.properties. The Parameter values cannot be determined. Please enter appropriate inputs before running this script again.	  
echo WAS_HOME
echo SERVICE
echo PRIMARY_DB_NAME
echo PRIMARY_DB_USERNAME
echo PRIMARY_DB_PASSWORD
echo PRIMARY_DB_IP
echo PRIMARY_DB_PORT
echo SELF_KEYSTORE_PASSWORD
exit 1
fi

. ${SCRIPTDIR}//agentStarter.properties

if [ ! $4 ]
then
echo Usage: 
echo		agentImportKS.sh "Path to WAS_HOME" "KS_TYPE" "KS_PATH" "KS_PASSWORD"
echo		
echo Example: 
echo		agentImportKS.sh /opt/IBM/WebSphere/AppServer JCEKS /home/user/testks.jks password 
echo Note:	Please ensure the WAS HOME path is correct.
exit 1
fi

export WAS_HOME=$1
export KS_TYPE=$2
export KS_PATH=$3
export KS_PASSWORD=$4

if [ ! -d ${WAS_HOME} ]
then
echo "WAS_HOME Path Invalid"
exit 1
fi

if [ !  ${JAVA_HOME} ]
then
export JAVA_HOME=${WAS_HOME}/java/8.0
fi

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME ${JAVA_HOME} is not directory."
exit 1
fi

if [ -z ${SELF_KEYSTORE_PASSWORD} ]
then 
echo "SELF_KEYSTORE_PASSWORD Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_NAME} ]
then 
echo "PRIMARY_DB_NAME Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_USERNAME} ]
then 
echo "PRIMARY_DB_USERNAME Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_PASSWORD} ]
then 
echo "PRIMARY_DB_PASSWORD Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_IP} ]
then 
echo "PRIMARY_DB_IP Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_PORT} ]
then 
echo "PRIMARY_DB_PORT Property is empty"
exit 1
fi




AGENT_CP=${SCRIPTDIR}/com.ibm.sklm.agent.jar:${WAS_HOME}/runtimes/com.ibm.ws.admin.client_9.0.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar:${WAS_HOME}/universalDriver/lib/db2jcc.jar:${WAS_HOME}/universalDriver/lib/db2jcc_license_cu.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.passwordpolicy.jar:${WAS_HOME}/runtimes/com.ibm.jaxws.thinclient_9.0.jar

#echo "****** AGENT_CP ${AGENT_CP}*******"

echo WAS_HOME=$1
echo KS_TYPE=$2
echo KS_PATH=$3
echo KS_PASSWORD= @@@@@

shopt -s nullglob
for f in ${WAS_HOME}/plugins/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/lib/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
echo ${JAVA_HOME}/bin/java -cp ${AGENT_CP} com.ibm.sklm.agent.utilities.SKLMImportKS ${KS_TYPE} ${KS_PATH} @@@@@@ > agentImportKS.log 2>&1
${JAVA_HOME}/bin/java -cp ${AGENT_CP} com.ibm.sklm.agent.utilities.SKLMImportKS ${KS_TYPE} ${KS_PATH} ${KS_PASSWORD} > agentImportKS.log 2>&1
rc=$?
if [ $GID -eq 0  ]; then
        chown ${PRIMARY_DB_USERNAME} ${SCRIPTDIR}/*.*
	    chown ${PRIMARY_DB_USERNAME} $WAS_HOME/products/sklm/logs/*.*
fi

if [ $rc -eq 0 ]; then
   	echo "Agent Import keystore successful"
else
	echo "Agent Import keystore failed."
	echo "Please check agentImportKS.log for more details."
fi

exit $rc
