#!/bin/sh

CURR_DIR=`pwd`
CURR_DIR=${CURR_DIR}/
echo "CURR_DIR=${CURR_DIR}"

export PATH=${PATH}:.

if [ ! -f restore.properties ]
then
echo "restore.properties file not found."
exit 1
fi

. restore.properties

if [ -z ${WAS_HOME} ]
then 
echo "WAS_HOME Property is empty"
exit 1
fi
if [ ! -d ${WAS_HOME} ]
then 
echo "WAS_HOME Property is not directory"
exit 1
fi

if [ -z ${RESTORE_USER_ROLES} ]
then 
	export RESTORE_USER_ROLES=n
	echo RESTORE_USER_ROLES=n>>./restore.properties
fi


if [ ${RESTORE_USER_ROLES} == y ]
then 
	echo "For EKM restore RESTORE_USER_ROLES property must be set to 'n'."
	exit 1
fi

if [ -z ${RESTORE_FILE} ]
then 
echo "RESTORE_FILE Property is empty"
exit 1
fi
if [ -z ${DB_PASSWORD} ]
then 
echo "DB_PASSWORD Property is empty"
exit 1
fi
if [ -z ${BACKUP_PASSWORD} ]
then 
echo "BACKUP_PASSWORD Property is empty"
exit 1
fi
if [ -z ${JAVA_HOME} ]
then
echo "JAVA_HOME Property is not set"
exit 1
fi
if [ ! -f ${JAVA_HOME}/bin/java ]
then
echo "Invalid JAVA_HOME directory set."
exit 1
fi


BACKUP_CP=${CURR_DIR}com.ibm.sklm.server.migrate.ekm21restore.jar:${WAS_HOME}/universalDriver/lib/db2jcc.jar:${WAS_HOME}/universalDriver/lib/db2jcc_license_cu.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/plugins/com.ibm.ws.runtime.jar:${WAS_HOME}/plugins/com.ibm.ws.prereq.xlxp.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.sklm.server.migrate.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.sklm.server.migrate.v1.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.tklm.keyserver.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.tklm.kmip.adapter.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.tklm.kmip.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.tklm.ksinterface.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.tklm.log4j.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.tklm.server.api.jar:${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/com.ibm.tklm.server.db.ejb.jar

#echo "****** BACKUP_CP ${BACKUP_CP}*******"

export WAS_HOME=${WAS_HOME}
#echo "***** WAS_HOME ${WAS_HOME}********"

${JAVA_HOME}/bin/java -cp ${BACKUP_CP} com.ibm.sklm.server.migrate.v2v.backup.RestoreHandlerV2V ${WAS_HOME} > restore_console.log 2>&1
rc=$?
if [ $rc -ne 0 ]; then
   	echo "Restore completed with errors, please refer to restore.log for more details."
else
	echo "Restore completed, please refer to restore.log for more details."
fi
exit 0
